<?xml version="1.0" encoding="utf-8" ?>
<toolkit:Popup xmlns="http://schemas.microsoft.com/dotnet/2021/maui"
               xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
               xmlns:toolkit="http://schemas.microsoft.com/dotnet/2022/maui/toolkit"
               xmlns:localization="clr-namespace:LocalizationResourceManager.Maui;assembly=LocalizationResourceManager.Maui"
               xmlns:ksmodels="clr-namespace:Kieselstein.Models"
               x:Class="KieselsteinErp.Terminal.Popups.ItemSearchPopup"
               CanBeDismissedByTappingOutsideOfPopup="False"
               Color="Transparent"
               Size="500,800">

  <toolkit:Popup.Resources>
    <ResourceDictionary>
      <toolkit:IsStringNotNullOrEmptyConverter x:Key="StringEmptyConverter" />
    </ResourceDictionary>
  </toolkit:Popup.Resources>
  
  <Border Style="{StaticResource PopupFrame}" VerticalOptions="Fill" >
    <Grid RowDefinitions="Auto,*">
      <Border Grid.Row="0" Style="{StaticResource PopupTitle}" x:Name="TitleBorder" >
        <Grid RowDefinitions="Auto" ColumnDefinitions="Auto" Margin="10" HorizontalOptions="Center" VerticalOptions="Start">
          <Label Grid.Row="0" Text="{localization:Translate ChooseItem}" />
        </Grid>
      </Border>
      
      <Grid Grid.Row="1" RowDefinitions="Auto,*,Auto" Margin="5">
        
        <Grid Grid.Row="0" ColumnDefinitions="Auto,*">
          <Label Grid.Column="0" Text="{localization:Translate Number}" FontSize="Micro" VerticalOptions="Center" HorizontalOptions="Start" />
          <SearchBar Grid.Column="1" x:Name="searchBar" Text="{Binding ItemCnr}" Placeholder="{localization:Translate ItemNumber}" Keyboard="Plain" FontAttributes="Bold" FontSize="Subtitle"
                  SearchCommand="{Binding SearchCommand}" SearchCommandParameter="{Binding Text, Source={x:Reference searchBar}}" />
        </Grid>

        <!-- item search list -->
        <Border Grid.Row="1" StrokeShape="RoundRectangle 5" IsVisible="{Binding IsListVisible}">
          <ListView Grid.Row="4" x:Name="searchList" ItemsSource="{Binding SearchResults}" SelectedItem="{Binding SelectedItem}" VerticalOptions="FillAndExpand" HasUnevenRows="True" >
            <ListView.Behaviors>
              <toolkit:EventToCommandBehavior EventName="ItemTapped" Command="{Binding ListTappedCommand}" />
            </ListView.Behaviors>
            <ListView.ItemTemplate>
              <DataTemplate x:DataType="{x:Type ksmodels:ItemV1Entry}">
                <ViewCell>
                  <Grid ColumnDefinitions="*" RowDefinitions="3,Auto,Auto,Auto,Auto,3" Padding="2" >
                    <Border Grid.Row="0" Grid.RowSpan="6" StrokeShape="RoundRectangle 3"  />
                    <Label Grid.Row="1"  Margin="3,0,3,0" x:Name="listItems" Text="{Binding cnr}" FontAttributes="Bold" VerticalOptions="Center" HorizontalOptions="Start"/>
                    <Label Grid.Row="2" Margin="3,0,3,0" Text="{Binding name}" FontAttributes="Bold" VerticalOptions="Center" HorizontalOptions="Start"/>
                    <Label Grid.Row="3" Margin="10,0,0,0" Text="{Binding description}" VerticalOptions="Center" HorizontalOptions="Start" IsVisible="{Binding description, Converter={StaticResource StringEmptyConverter}}"/>
                    <Label Grid.Row="4" Margin="10,0,0,0" Text="{Binding description2}" VerticalOptions="Center" HorizontalOptions="Start" IsVisible="{Binding description2, Converter={StaticResource StringEmptyConverter}}"/>
                    <Label Grid.Row="5" Text="" />
                  </Grid>
                </ViewCell>
              </DataTemplate>
            </ListView.ItemTemplate>
          </ListView>
        </Border>

        <Button Grid.Row="2" Text="{localization:Translate Close}" Command="{Binding CancelCommand}" VerticalOptions="End" />
      </Grid>
      
      <AbsoluteLayout Grid.Row="0" Grid.RowSpan="2" x:Name="Loading" IsVisible="{Binding IsLoadingCircleVisible}">
        <BoxView Color="Black" Opacity="0.5" AbsoluteLayout.LayoutFlags="All" AbsoluteLayout.LayoutBounds="0, 0, 1, 1" />
        <ActivityIndicator IsRunning="True" Color="White" AbsoluteLayout.LayoutFlags="PositionProportional" AbsoluteLayout.LayoutBounds="0.5, 0.5, -1, -1" />
      </AbsoluteLayout>

    </Grid>
  </Border>
</toolkit:Popup>